public abstract class TestableObjectBase
{
  // Prints the results of the testing.
  public void printResults()
  {
    // This contains some horrible code duplication, but fixing this requires complicated Java constructs
    // which have not been treated yet and would make the code harder to read and understand.
    if (faultyTriangleContainmentTests > 0)
    {
      System.out.println("Some triangle containment tests were incorrect: the expected answer was wrong.");
    }
    else if (triangleContainmentFaultsFound > 0)
    {
      System.out.println("Some triangle containment faults were found in the implementation.");
    }
    else if (triangleContainmentIsFaulty())
    {
      System.out.println("No triangle containment faults were found in the implementation, but faults do exist.");
    }
    else
    {
      System.out.println("No triangle containment faults were found in the implementation, which is correct.");
    }
    
    if (faultyEditDistanceTests > 0)
    {
      System.out.println("Some edit distance tests were incorrect: the expected answer was wrong.");
    }
    else if (editDistanceFaultsFound > 0)
    {
      System.out.println("Some edit distance faults were found in the implementation.");
    }
    else if (editDistanceIsFaulty())
    {
      System.out.println("No edit distance faults were found in the implementation, but faults do exist.");
    }
    else
    {
      System.out.println("No edit distance faults were found in the implementation, which is correct.");
    }
    
    if (faultyKromFormulaTests > 0)
    {
      System.out.println("Some Krom formula tests were incorrect: the expected answer was wrong.");
    }
    else if (kromFormulaFaultsFound > 0)
    {
      System.out.println("Some Krom formula faults were found in the implementation.");
    }
    else if (kromFormulaIsFaulty())
    {
      System.out.println("No Krom formula faults were found in the implementation, but faults do exist.");
    }
    else
    {
      System.out.println("No Krom formula faults were found in the implementation, which is correct.");
    }
  }
  
  // Triangle containment
  private int faultyTriangleContainmentTests = 0;
  private int triangleContainmentFaultsFound = 0;
  public void testTriangleContains(int x1, int y1, int x2, int y2, int x3, int y3, int xtest, int ytest, boolean expectedAnswer)
  {
    // Just making sure that a case that causes the code to crash is counted as faulty.
    faultyTriangleContainmentTests++;
    try
    {
      boolean possiblyFaultyResult = triangleContains(x1, y1, x2, y2, x3, y3, xtest, ytest);
      boolean correctResult = triangleContainsCorrect(x1, y1, x2, y2, x3, y3, xtest, ytest);
      faultyTriangleContainmentTests--; // Undo the above.
      
      if (correctResult != expectedAnswer)
      {
        faultyTriangleContainmentTests++;
      }
      else if (possiblyFaultyResult != expectedAnswer)
      {
        triangleContainmentFaultsFound++;
      }
    }
    catch (Throwable t)
    {
    }
  }
  protected abstract boolean triangleContainmentIsFaulty();
  protected abstract boolean triangleContains(int x1, int y1, int x2, int y2, int x3, int y3, int xtest, int ytest);
  private boolean triangleContainsCorrect(int x1, int y1, int x2, int y2, int x3, int y3, int xtest, int ytest)
  {
    // The Peach version of this file has a correct implementation of course.
    return true;
  }
  
  // Edit distance
  private int faultyEditDistanceTests = 0;
  private int editDistanceFaultsFound = 0;
  public void testEditDistance(String first, String second, int expectedAnswer)
  {
    // Just making sure that a case that causes the code to crash is counted as faulty.
    faultyEditDistanceTests++;
    try
    {
      int possiblyFaultyResult = editDistance(first, second);
      int correctResult = editDistanceCorrect(first, second);
      faultyEditDistanceTests--; // Undo the above.
      if (correctResult != expectedAnswer)
      {
        faultyEditDistanceTests++;
      }
      else if (possiblyFaultyResult != expectedAnswer)
      {
        editDistanceFaultsFound++;
      }
    }
    catch (Throwable t)
    {
    }
  }
  protected abstract boolean editDistanceIsFaulty();
  protected abstract int editDistance(String first, String second);
  private int editDistanceCorrect(String first, String second)
  {
    // The Peach version of this file has a correct implementation of course.
    return 0;
  }
  
  // Krom formulas
  private int faultyKromFormulaTests = 0;
  private int kromFormulaFaultsFound = 0;
  public void testKromFormula(int variables, KromClause[] formula, boolean expectedAnswer)
  {
    // Copy the array for safety (references are sometimes annoying).
    KromClause[] myFormula = new KromClause[formula.length];
    for (int i = 0; i < formula.length; i++) myFormula[i] = formula[i];
    // Just making sure that a case that causes the code to crash is counted as faulty.
    faultyKromFormulaTests++;
    try
    {
      boolean possiblyFaultyResult = kromFormula(variables, formula);
      boolean correctResult = kromFormulaCorrect(variables, formula);
      faultyKromFormulaTests--; // Undo the above.
      if (correctResult != expectedAnswer)
      {
        faultyKromFormulaTests++;
      }
      else if (possiblyFaultyResult != expectedAnswer)
      {
        kromFormulaFaultsFound++;
      }
    }
    catch (Throwable t)
    {
    }
  }
  protected abstract boolean kromFormulaIsFaulty();
  protected abstract boolean kromFormula(int variables, KromClause[] formula);
  private boolean kromFormulaCorrect(int variables, KromClause[] formula)
  {
    // The Peach version of this file has a correct implementation of course.
    return true;
  }
}